﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XamGridDynamicRowColorCase
{
    public class ViewModel
    {
        string[] names = "Andrew;Alex;Jen;Steve;Murphy;Eric;Tom;Rich;Mary;Valerie;Pamela;Rob;Mike".Split(';');

        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<names.Length; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Name = names[i],
                    Birthday = DateTime.Today.AddYears((r.Next(1, 50) * -1)),
                });
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {

        private int _id;
        private string _name;
        private DateTime _dob;

        public int ID
        {
            get { return _id; }
            set
            {
                if(_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }        

        public string Name
        {
            get { return _name; }
            set
            {
                if(_name != value)
                {
                    _name = value;
                    OnPropertyChanged();
                }
            }
        }   

        public DateTime Birthday
        {
            get { return _dob; }
            set
            {
                if(_dob != value)
                {
                    _dob = value;
                    OnPropertyChanged();
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }


    }
}
